"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _Delimeter = _interopRequireDefault(require("./Delimeter"));

var _delimeter = require("./consts/delimeter");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Delimeter spec', function () {
  it('renders with default values', function () {
    var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_Delimeter.default, null));
    var span = wrapper.find('span');
    expect(span).toHaveLength(1);
    expect(span.hasClass(_delimeter.DELIMETER)).toBeTruthy();
    expect(span.contains(_delimeter.DEFAULT_DELIMETER)).toBeTruthy();
  });
  it('should set className', function () {
    var two = 'two';
    var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_Delimeter.default, {
      className: two
    }));
    expect(wrapper.find('span').hasClass(two)).toBeTruthy();
  });
  it('should set value', function () {
    var value = '______';
    var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_Delimeter.default, {
      value: value
    }));
    expect(wrapper.find('span').contains(value)).toBeTruthy();
  });
});