"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Picker = _interopRequireDefault(require("./Picker"));

var _Input = _interopRequireDefault(require("./Input"));

var _Delimeter = _interopRequireDefault(require("./Delimeter"));

var _Control = _interopRequireDefault(require("./Control"));

var _Label = _interopRequireDefault(require("./Label"));

var _paginator = require("./utils/paginator");

var _functional = require("./utils/functional");

var _string = require("./utils/string");

var _core = require("./consts/core");

var _labels = require("./consts/labels");

var _controls = require("./consts/controls");

var _paginator2 = require("./consts/paginator");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Paginator =
/*#__PURE__*/
function (_Component) {
  _inherits(Paginator, _Component);

  function Paginator(props) {
    var _this;

    _classCallCheck(this, Paginator);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Paginator).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onPickerChange", function (value) {
      var index = _this.convertValueToIndex(value);

      var currentIndex = _this.state.currentIndex;

      if (index === currentIndex) {
        _this.toggleDirection();

        return;
      }

      _this.setState({
        currentIndex: index
      });

      _this.props.onPickerChange(index);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "validateInput", function (value) {
      var castToNumber = Number(value);
      return !isNaN(castToNumber) && isFinite(castToNumber) && castToNumber > 0 && castToNumber <= _this.state.allPickers;
    });

    var valuePerPage = props.valuePerPage,
        amount = props.amount,
        amountPickersToShow = props.amountPickersToShow,
        initIndex = props.initIndex;
    var allPickers = (0, _paginator.calculateAllAvailablePickers)(amount, valuePerPage);
    _this.state = {
      currentIndex: initIndex,
      valuePerPage: valuePerPage,
      allPickers: allPickers,
      visiblePickers: (0, _paginator.calculateVisiblePickers)(allPickers, amountPickersToShow),
      direction: {
        up: true,
        down: false
      }
    };
    return _this;
  }

  _createClass(Paginator, [{
    key: "toggleDirection",
    value: function toggleDirection() {
      var direction = this.state.direction;
      var up = direction.up,
          down = direction.down;
      var newDirection = {
        up: !up,
        down: !down
      };
      this.setState({
        direction: newDirection
      });
    }
  }, {
    key: "convertValueToIndex",
    value: function convertValueToIndex(value) {
      var _this$props = this.props,
          firstLabel = _this$props.firstLabel,
          lastLabel = _this$props.lastLabel,
          controlUp = _this$props.controlUp,
          controlDown = _this$props.controlDown;
      var _this$state = this.state,
          allPickers = _this$state.allPickers,
          currentIndex = _this$state.currentIndex;

      switch (value) {
        case firstLabel:
          return 1;

        case lastLabel:
          return allPickers;

        case controlUp:
          return currentIndex + 1;

        case controlDown:
          return currentIndex - 1;

        default:
          return value;
      }
    }
  }, {
    key: "calculateLabels",
    value: function calculateLabels() {
      var _this$props2 = this.props,
          enableLabels = _this$props2.enableLabels,
          firstLabel = _this$props2.firstLabel,
          lastLabel = _this$props2.lastLabel;
      return enableLabels ? {
        firstLabel: firstLabel,
        lastLabel: lastLabel
      } : {};
    }
  }, {
    key: "calculateControls",
    value: function calculateControls() {
      var _this$props3 = this.props,
          enableControls = _this$props3.enableControls,
          controlUp = _this$props3.controlUp,
          controlDown = _this$props3.controlDown;
      return enableControls ? {
        controlUp: controlUp,
        controlDown: controlDown
      } : {};
    }
  }, {
    key: "calculateDelimeter",
    value: function calculateDelimeter() {
      var _this$props4 = this.props,
          enableDelimeter = _this$props4.enableDelimeter,
          delimeterValue = _this$props4.delimeterValue;
      return enableDelimeter ? delimeterValue : false;
    }
  }, {
    key: "calculateIndexes",
    value: function calculateIndexes() {
      var _this$state2 = this.state,
          currentIndex = _this$state2.currentIndex,
          allPickers = _this$state2.allPickers,
          visiblePickers = _this$state2.visiblePickers,
          direction = _this$state2.direction;
      var up = direction.up,
          down = direction.down;
      return (0, _paginator.calculateIndexes)({
        currentIndex: currentIndex,
        up: up,
        down: down,
        all: allPickers,
        visibleAmount: visiblePickers
      });
    }
  }, {
    key: "calculateSequence",
    value: function calculateSequence() {
      var indexes = this.calculateIndexes();
      var _this$state3 = this.state,
          currentIndex = _this$state3.currentIndex,
          allPickers = _this$state3.allPickers,
          visiblePickers = _this$state3.visiblePickers;
      return (0, _paginator.producePickerMap)({
        withLast: indexes.length !== visiblePickers,
        labels: this.calculateLabels(),
        delimeter: this.calculateDelimeter(),
        controls: this.calculateControls(),
        currentIndex: currentIndex,
        indexes: indexes,
        lastIndex: allPickers
      });
    }
  }, {
    key: "isDelimeter",
    value: function isDelimeter(value) {
      return value === this.props.delimeterValue;
    }
  }, {
    key: "isControl",
    value: function isControl(value) {
      return value === this.props.controlUp || value === this.props.controlDown;
    }
  }, {
    key: "isLabel",
    value: function isLabel(value) {
      return value === this.props.firstLabel || value === this.props.lastLabel;
    }
  }, {
    key: "generateDelimeter",
    value: function generateDelimeter(value) {
      var _this$props5 = this.props,
          customDelimeterComponent = _this$props5.customDelimeterComponent,
          delimeterClassName = _this$props5.delimeterClassName;
      var DelimeterComponent = customDelimeterComponent;
      return _react.default.createElement(DelimeterComponent, {
        key: value,
        className: delimeterClassName,
        value: value
      });
    }
  }, {
    key: "generatePicker",
    value: function generatePicker(value, disabled, picked) {
      var _this$props6 = this.props,
          customPickerComponent = _this$props6.customPickerComponent,
          pickerClassName = _this$props6.pickerClassName;
      var PickerComponent = customPickerComponent;
      return _react.default.createElement(PickerComponent, {
        key: "".concat(value).concat(disabled).concat(picked),
        className: pickerClassName,
        value: value,
        disabled: disabled,
        picked: picked,
        onClick: this.onPickerChange
      });
    }
  }, {
    key: "generateControl",
    value: function generateControl(value, disabled) {
      var _this$props7 = this.props,
          customControlComponent = _this$props7.customControlComponent,
          controlClassName = _this$props7.controlClassName;
      var ControlComponent = customControlComponent;
      return _react.default.createElement(ControlComponent, {
        key: "".concat(value).concat(disabled),
        className: controlClassName,
        value: value,
        disabled: disabled,
        onClick: this.onPickerChange
      });
    }
  }, {
    key: "generateLabel",
    value: function generateLabel(value, disabled) {
      var _this$props8 = this.props,
          customLabelComponent = _this$props8.customLabelComponent,
          labelClassName = _this$props8.labelClassName;
      var LabelComponent = customLabelComponent;
      return _react.default.createElement(LabelComponent, {
        key: "".concat(value).concat(disabled),
        className: labelClassName,
        value: value,
        disabled: disabled,
        onClick: this.onPickerChange
      });
    }
  }, {
    key: "generateSequence",
    value: function generateSequence() {
      var _this2 = this;

      return this.calculateSequence().map(function (_ref) {
        var value = _ref.value,
            disabled = _ref.disabled,
            picked = _ref.picked;

        if (_this2.isDelimeter(value)) {
          return _this2.generateDelimeter(value);
        }

        if (_this2.isLabel(value)) {
          return _this2.generateLabel(value, disabled);
        }

        if (_this2.isControl(value)) {
          return _this2.generateControl(value, disabled);
        }

        return _this2.generatePicker(value, disabled, picked);
      });
    }
  }, {
    key: "generateInputControl",
    value: function generateInputControl() {
      var _this$props9 = this.props,
          enableInputControl = _this$props9.enableInputControl,
          customInputComponent = _this$props9.customInputComponent,
          inputControlValidator = _this$props9.inputControlValidator,
          inputClassName = _this$props9.inputClassName;
      var currentIndex = this.state.currentIndex;

      if (!enableInputControl) {
        return null;
      }

      var InputComponent = customInputComponent;
      var validator = inputControlValidator || this.validateInput;
      return _react.default.createElement(InputComponent, {
        className: inputClassName,
        validator: validator,
        onChange: this.onPickerChange,
        value: currentIndex
      });
    }
  }, {
    key: "render",
    value: function render() {
      var className = this.props.className;
      return _react.default.createElement("div", {
        className: (0, _string.skipEmptyClassNames)([_paginator2.PAGINATOR, className])
      }, this.generateInputControl(), this.generateSequence());
    }
  }]);

  return Paginator;
}(_react.Component);

exports.default = Paginator;
Paginator.defaultProps = {
  /** assets configuration **/
  valuePerPage: _paginator2.DEFAULT_VALUE_PER_PAGE,
  amountPickersToShow: _paginator2.DEFAULT_AMOUNT_PICKERS_TO_SHOW,
  className: _core.EMPTY,

  /** customization **/
  customPickerComponent: _Picker.default,
  pickerClassName: _core.EMPTY,

  /** delimeter configuration **/
  enableDelimeter: _paginator2.DEFAULT_ENABLE.DELIMETER,
  customDelimeterComponent: _Delimeter.default,
  delimeterValue: _paginator2.DEFAULT_DELIMETER,
  delimeterClassName: _core.EMPTY,

  /** labels configuration **/
  enableLabels: _paginator2.DEFAULT_ENABLE.LABELS,
  customLabelComponent: _Label.default,
  firstLabel: _labels.FIRST,
  lastLabel: _labels.LAST,
  labelClassName: _core.EMPTY,

  /** controls configuration **/
  enableControls: _paginator2.DEFAULT_ENABLE.CONTROLS,
  customControlComponent: _Control.default,
  controlUp: _controls.CONTROL_UP,
  controlDown: _controls.CONTROL_DOWN,
  controlClassName: _core.EMPTY,

  /** input configuration **/
  enableInputControl: _paginator2.DEFAULT_ENABLE.INPUT_CONTROL,
  customInputComponent: _Input.default,
  inputClassName: _core.EMPTY,

  /** base configuration **/
  onPickerChange: _functional.noop,
  initIndex: _paginator2.DEFAULT_INIT_INDEX
};
Paginator.propTypes = {
  /** mandatory prop **/
  amount: _propTypes.default.number.isRequired,

  /** assets configuration **/
  valuePerPage: _propTypes.default.number,
  amountPickersToShow: _propTypes.default.number,
  className: _propTypes.default.string,

  /** customization **/
  customPickerComponent: _propTypes.default.any,
  pickerClassName: _propTypes.default.string,

  /** delimeter configuration **/
  enableDelimeter: _propTypes.default.bool,
  customDelimeterComponent: _propTypes.default.any,
  delimeterValue: _propTypes.default.string,
  delimeterClassName: _propTypes.default.string,

  /** labels configuration **/
  enableLabels: _propTypes.default.bool,
  customLabelComponent: _propTypes.default.any,
  firstLabel: _propTypes.default.string,
  lastLabel: _propTypes.default.string,
  labelClassName: _propTypes.default.string,

  /** controls configuration **/
  enableControls: _propTypes.default.bool,
  customControlComponent: _propTypes.default.any,
  controlUp: _propTypes.default.any,
  controlDown: _propTypes.default.any,
  controlClassName: _propTypes.default.string,

  /** input configuration **/
  enableInputControl: _propTypes.default.bool,
  customInputComponent: _propTypes.default.any,
  inputControlValidator: _propTypes.default.func,
  inputClassName: _propTypes.default.string,

  /** base configuration **/
  onPickerChange: _propTypes.default.func,
  initIndex: _propTypes.default.number
};