"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assert = exports.pipe = exports.identity = exports.noop = void 0;

var noop = function noop() {};

exports.noop = noop;

var identity = function identity(arg) {
  return arg;
};

exports.identity = identity;

var pipe = function pipe() {
  for (var _len = arguments.length, funcs = new Array(_len), _key = 0; _key < _len; _key++) {
    funcs[_key] = arguments[_key];
  }

  if (!funcs.length) {
    return identity;
  }

  if (funcs.length === 1) {
    return funcs[0];
  }

  return funcs.reduceRight(function (a, b) {
    return function () {
      return a(b.apply(void 0, arguments));
    };
  });
};

exports.pipe = pipe;

var assert = function assert(condition, message) {
  if (!condition) {
    throw new Error("Assertion failed: ".concat(message));
  }

  return condition;
};

exports.assert = assert;