"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.skipEmptyClassNames = exports.constructClassName = void 0;

var _core = require("../consts/core");

var constructClassName = function constructClassName() {
  var classes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return classes.reduce(function (prev, className) {
    var needBreak = config.break && config.break.indexOf(className) !== -1;
    prev = needBreak ? prev : "".concat(prev, " ").concat(className);
    return prev.trim();
  }, '');
};

exports.constructClassName = constructClassName;

var skipEmptyClassNames = function skipEmptyClassNames(classes) {
  return constructClassName(classes, {
    break: [_core.EMPTY]
  });
};

exports.skipEmptyClassNames = skipEmptyClassNames;