"use strict";

var _string = require("./string");

var _core = require("../consts/core");

describe('string utils spec', function () {
  describe('constructClassName', function () {
    it('should return empty string if no values provided', function () {
      expect((0, _string.constructClassName)()).toBe('');
      expect((0, _string.constructClassName)([])).toBe('');
    });
    it('should return className string, whne classes are provided', function () {
      var expected = 'one two three';
      expect((0, _string.constructClassName)(['one', 'two', 'three'])).toBe(expected);
    });
    it('should create className string, depending on provided config', function () {
      var expected = 'one four';
      expect((0, _string.constructClassName)(['two', 'one', 'three', 'four', 'two'], {
        break: ['two', 'three']
      })).toBe(expected);
    });
  });
  describe('skipEmptyClassNames', function () {
    it('should skip EMPTY classNames', function () {
      var expected = 'one two';
      expect((0, _string.skipEmptyClassNames)([_core.EMPTY, _core.EMPTY, 'one', _core.EMPTY, 'two'])).toBe(expected);
    });
  });
});